Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QuasiFreeRatios.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QuasiFreeRatios.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4QuasiFreeRatios.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4QuasiFreeRatios.cc,v 1.19 2008/03/21 21:44:39 dennis Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4QuasiFreeRatios.cc,v 1.21 2009/04/09 08:25:46 mkossov Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 //
@@ -33,5 +33,8 @@
 // The last update: M.V. Kossov, CERN/ITEP (Moscow) 15-Oct-06
 // 
-//================================================================================
+//=======================================================================
+// Short description: Provides percentage of quasi-free and quasi-elastic
+// reactions in the inelastic reactions.
+// ----------------------------------------------------------------------
 
 //#define debug
@@ -50,5 +53,5 @@
 {
 #ifdef pdebug
-		G4cout<<"***^^^*** G4QuasiFreeRatios singletone is created ***^^^***"<<G4endl;
+  G4cout<<"***^^^*** G4QuasiFreeRatios singletone is created ***^^^***"<<G4endl;
 #endif
 }
@@ -81,12 +84,22 @@
                                                            G4int tgZ,    G4int tgN)
 {
-		std::pair<G4double,G4double> ElTot=GetElTot(pIU, pPDG, tgZ, tgN); // mean hN El&Tot(IU)
+#ifdef pdebug
+  G4cout<<">>>IN>>>G4QFRat::GetQF:P="<<pIU<<",pPDG="<<pPDG<<",Z="<<tgZ<<",N="<<tgN<<G4endl;
+#endif
   G4double R=0.;
-  G4double QF2In=1.;               // Prototype of QuasiFree/Inelastic ratio for hN_tot
-  if(ElTot.second>0.)
-  {
-    R=ElTot.first/ElTot.second;    // Elastic/Total ratio (does not depend on units
-    QF2In=GetQF2IN_Ratio(ElTot.second/millibarn, tgZ+tgN); // QuasiFree/Inelastic ratio
-  }
+  G4double QF2In=1.;                        // Prototype of QuasiFree/Inel ratio for hN_tot
+  G4int tgA=tgZ+tgN;
+  if(tgA<2) return std::make_pair(QF2In,R); // No quasi-elastic on the only nucleon
+  std::pair<G4double,G4double> ElTot=GetElTot(pIU, pPDG, tgZ, tgN); // mean hN El&Tot(IU)
+  //if( ( (pPDG>999 && pIU<227.) || pIU<27.) && tgA>1) R=1.; // @@ TMP to accelerate @lowE
+  if(pPDG>999 && pIU<227. && tgZ+tgN>1) R=1.;                // To accelerate @lowE
+  else if(ElTot.second>0.)
+  {
+    R=ElTot.first/ElTot.second;             // El/Total ratio (does not depend on units
+    QF2In=GetQF2IN_Ratio(ElTot.second/millibarn, tgZ+tgN);   // QuasiFree/Inelastic ratio
+  }
+#ifdef pdebug
+  G4cout<<">>>OUT>>>G4QuasiFreeRatio::GetQF2IN_Ratio: QF2In="<<QF2In<<", R="<<R<<G4endl;
+#endif
   return std::make_pair(QF2In,R);
 }
@@ -125,4 +138,7 @@
   static G4double* lastL=0;             // theLast of pointer to LogTable in the C++ heap
   // LogTable is created only if necessary. The ratio R(s>8100 mb) = 0 for any nuclei
+#ifdef pdebug
+  G4cout<<"+++G4QuasiFreeRatio::GetQF2IN_Ratio:A="<<A<<", s="<<s<<G4endl;
+#endif
   if(s<toler || A<2) return 1.;
   if(s>ms) return 0.;
@@ -137,14 +153,17 @@
   G4bool found=false;
   G4int i=-1;
-		if(nDB) for (i=0; i<nDB; i++) if(A==vA[i]) // Sirch for this A in AMDB
+  if(nDB) for (i=0; i<nDB; i++) if(A==vA[i]) // Sirch for this A in AMDB
   {
     found=true;                         // The A value is found
     break;
   }
+#ifdef pdebug
+  G4cout<<"+++G4QuasiFreeRatio::GetQF2IN_Ratio: nDB="<<nDB<<", found="<<found<<G4endl;
+#endif
   if(!nDB || !found)                    // Create new line in the AMDB
-	 {
+  {
     lastA = A;
 #ifdef pdebug
-				G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: NewT, A="<<A<<", nDB="<<nDB<<G4endl;
+    G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: NewT, A="<<A<<", nDB="<<nDB<<G4endl;
 #endif
     lastT = new G4double[mps];          // Create the linear Table
@@ -163,10 +182,10 @@
       lastT[j]=CalcQF2IN_Ratio(sv,A);
     }
+    lastL=new G4double[mls];          // Create the logarithmic Table
     if(s>sma)                           // Initialize the logarithmic Table
     {
 #ifdef pdebug
-				G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: NewL, A="<<A<<", nDB="<<nDB<<G4endl;
-#endif
-      lastL=new G4double[mls];          // Create the logarithmic Table
+      G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: NewL, A="<<A<<", nDB="<<nDB<<G4endl;
+#endif
       G4double ls=std::log(s);
       lastK = static_cast<int>((ls-lsi)/dl)+1; // MaxBin to be initialized in LogTaB
@@ -181,10 +200,9 @@
       {
         lastL[j]=CalcQF2IN_Ratio(sv,A);
-	       if(j!=lastK) sv*=edl;
+        if(j!=lastK) sv*=edl;
       }
     }
     else                                // LogTab is not initialized
     {
-      lastL = 0;
       lastK = 0;
       lastM = 0.;
@@ -200,5 +218,5 @@
   }
   else                                  // The A value was found in AMDB
-	 {
+  {
     lastA=vA[i];
     lastH=vH[i];
@@ -208,7 +226,13 @@
     lastT=vT[i];
     lastL=vL[i];
+#ifdef pdebug
+    G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: Found, s="<<s<<", lastM="<<lastM<<G4endl;
+#endif
     if(s>lastM)                          // At least LinTab must be updated
     {
       G4int nextN=lastN+1;               // The next bin to be initialized
+#ifdef pdebug
+      G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: lastN="<<lastN<<" ?< nps="<<nps<<G4endl;
+#endif
       if(lastN<nps)
       {
@@ -226,13 +250,23 @@
           lastT[j]=CalcQF2IN_Ratio(sv,A);
         }
+#ifdef pdebug
+        G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: End of LinTab update"<<G4endl;
+#endif
       } // End of LinTab update
+#ifdef pdebug
+      G4cout<<"G4QFRatios::GetQF2IN_Ratio: lN="<<lastN<<", nN="<<nextN<<", i="<<i<<G4endl;
+#endif
       if(lastN>=nextN)
-						{
+      {
         vH[i]=lastH;
         vN[i]=lastN;
       }
       G4int nextK=lastK+1;
+      if(!lastK) nextK=0;
+#ifdef pdebug
+      G4cout<<"G4QFRat::GetQF2IN_Ratio: sma="<<sma<<", lastK="<<lastK<<" < "<<nls<<G4endl;
+#endif
       if(s>sma && lastK<nls)             // LogTab must be updated
-						{
+      {
         G4double sv=std::exp(lastM+lsi); // Define starting poit (lastM will be changed)
         G4double ls=std::log(s);
@@ -244,12 +278,24 @@
         }
         else lastM = lastK*dl;           // Calculate max initialized ln(s)-lsi for LogTab
+#ifdef pdebug
+        G4cout<<"G4QFRat::GetQF2IN_Ratio: nK="<<nextK<<", lK="<<lastK<<", sv="<<sv<<G4endl;
+#endif
         for(G4int j=nextK; j<=lastK; j++)// Calculate LogTab values
         {
-	         sv*=edl;
+          sv*=edl;
+#ifdef pdebug
+          G4cout<<"G4QFRat::GetQF2IN_Ratio: j="<<j<<", sv="<<sv<<", A="<<A<<G4endl;
+#endif
           lastL[j]=CalcQF2IN_Ratio(sv,A);
         }
+#ifdef pdebug
+        G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: End of LinTab update"<<G4endl;
+#endif
       } // End of LogTab update
+#ifdef pdebug
+      G4cout<<"G4QFRatios::GetQF2IN_Ratio: lK="<<lastK<<", nK="<<nextK<<", i="<<i<<G4endl;
+#endif
       if(lastK>=nextK)
-						{
+      {
         vM[i]=lastM;
         vK[i]=lastK;
@@ -257,7 +303,10 @@
     }
   }
+#ifdef pdebug
+  G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: BeforeTab s="<<s<<", sma="<<sma<<G4endl;
+#endif
   // Now one can use tabeles to calculate the value
   if(s<sma)                             // Use linear table
-		{
+  {
     G4int n=static_cast<int>(s/ds);     // Low edge number of the bin
     G4double d=s-n*ds;                  // Linear shift
@@ -265,6 +314,6 @@
     lastR=v+d*(lastT[n+1]-v)/ds;        // Result
   }
-		else                                  // Use log table
-		{
+  else                                  // Use log table
+  {
     G4double ls=std::log(s)-lsi;        // ln(s)-l_min
     G4int n=static_cast<int>(ls/dl);    // Low edge number of the bin
@@ -275,4 +324,7 @@
   if(lastR<0.) lastR=0.;
   if(lastR>1.) lastR=1.;
+#ifdef pdebug
+  G4cout<<"G4QuasiFreeRatios::GetQF2IN_Ratio: BeforeRet lastR="<<lastR<<G4endl;
+#endif
   return lastR;
 } // End of CalcQF2IN_Ratio
@@ -282,11 +334,11 @@
 {
   static const G4double C=1.246;
-		G4double s2=s*s;
+  G4double s2=s*s;
   G4double s4=s2*s2;
-		G4double ss=std::sqrt(std::sqrt(s));
+  G4double ss=std::sqrt(std::sqrt(s));
   G4double P=7.48e-5*s2/(1.+8.77e12/s4/s4/s2);
   G4double E=.2644+.016/(1.+std::exp((29.54-s)/2.49));
   G4double F=ss*.1526*std::exp(-s2*ss*.0000859);
-	 return C*std::exp(-E*std::pow(G4double(A-1.),F))/std::pow(G4double(A),P);
+  return C*std::exp(-E*std::pow(G4double(A-1.),F))/std::pow(G4double(A),P);
 } // End of CalcQF2IN_Ratio
 
@@ -309,7 +361,7 @@
   }
   if     (!I)                          // pp/nn
-		{
+  {
 #ifdef debug
-				G4cout<<"G4QuasiFreeR::CalcElTot:I=0, p="<<p<<", pmi="<<pmi<<", pma="<<pma<<G4endl;
+    G4cout<<"G4QuasiFreeR::CalcElTot:I=0, p="<<p<<", pmi="<<pmi<<", pma="<<pma<<G4endl;
 #endif
     if(p<pmi)
@@ -319,5 +371,5 @@
       To=El;
 #ifdef debug
-				  G4cout<<"G4QuasiFreeR::CalcElTot:I=0i, El="<<El<<", To="<<To<<", p2="<<p2<<G4endl;
+      G4cout<<"G4QuasiFreeR::CalcElTot:I=0i, El="<<El<<", To="<<To<<", p2="<<p2<<G4endl;
 #endif
     }
@@ -329,5 +381,5 @@
       To=pbt*lp2+38.2;
 #ifdef debug
-				  G4cout<<"G4QuasiFreeR::CalcElTot:I=0a, El="<<El<<", To="<<To<<", lp2="<<lp2<<G4endl;
+      G4cout<<"G4QuasiFreeR::CalcElTot:I=0a, El="<<El<<", To="<<To<<", lp2="<<lp2<<G4endl;
 #endif
     }
@@ -342,10 +394,10 @@
       To=LE+(pbt*lp2+38.2+52.7*rp2)/(1.+2.72*rp2*rp2);
 #ifdef debug
-				  G4cout<<"G4QuasiFreeR::CalcElTot:0,E="<<El<<",T="<<To<<",s="<<p2<<",l="<<lp2<<G4endl;
+      G4cout<<"G4QuasiFreeR::CalcElTot:0,E="<<El<<",T="<<To<<",s="<<p2<<",l="<<lp2<<G4endl;
 #endif
     }
   }
   else if(I==1)                        // np/pn
-		{
+  {
     if(p<pmi)
     {
@@ -373,5 +425,5 @@
   }
   else if(I==2)                        // pimp/pipn
-		{
+  {
     G4double lp=std::log(p);
     if(p<pmi)
@@ -407,5 +459,5 @@
   }
   else if(I==3)                        // pipp/pimn
-		{
+  {
     G4double lp=std::log(p);
     if(p<pmi)
@@ -440,6 +492,6 @@
     }
   }
-		else if(I==4)                        // Kmp/Kmn/K0p/K0n
-		{
+  else if(I==4)                        // Kmp/Kmn/K0p/K0n
+  {
 
     if(p<pmi)
@@ -473,5 +525,5 @@
   }
   else if(I==5)                        // Kpp/Kpn/aKp/aKn
-		{
+  {
     if(p<pmi)
     {
@@ -505,5 +557,5 @@
   }
   else if(I==6)                        // hyperon-N
-		{
+  {
     if(p<pmi)
     {
@@ -533,5 +585,5 @@
   }
   else if(I==7)                        // antibaryon-N
-		{
+  {
     if(p>pma)
     {
@@ -571,5 +623,5 @@
   static const G4double dl=(lpa-lpi)/nlp;// Step of the logarithmic Table
   static const G4double edl=std::exp(dl);// Multiplication step of the logarithmic Table
-  //  static const G4double toler=.001;      // Relative tolarence defining "the same momentum"
+  //static const G4double toler=.001;      // Relative Tolarence defining "theSameMomentum"
   static G4double lastP=0.;              // The last momentum for which XS was calculated
   static G4int    lastH=0;               // The last projPDG for which XS was calculated
@@ -590,5 +642,5 @@
   G4cout<<"G4QuasiFreeR::FetchElTot:p="<<p<<",PDG="<<PDG<<",F="<<F<<",nDB="<<nDB<<G4endl;
 #endif
-  if(nDB && lastH==PDG && lastF==F && p>0. && p==lastP) return lastR; // VI do not use toler
+  if(nDB && lastH==PDG && lastF==F && p>0. && p==lastP) return lastR;// VI don't use toler.
   //  if(nDB && lastH==PDG && lastF==F && p>0. && std::fabs(p-lastP)/p<toler) return lastR;
   lastH=PDG;
@@ -596,5 +648,5 @@
   G4int ind=-1;                          // Prototipe of the index of the PDG/F combination
   // i=0: pp(nn), i=1: np(pn), i=2: pimp(pipn), i=3: pipp(pimn), i=4: Kmp(Kmn,K0n,K0p),
-		// i=5: Kpp(Kpn,aK0n,aK0p), i=6: Hp(Hn), i=7: app(apn,ann,anp) 
+  // i=5: Kpp(Kpn,aK0n,aK0p), i=6: Hp(Hn), i=7: app(apn,ann,anp) 
   G4bool kfl=true;                             // Flag of K0/aK0 oscillation
   G4bool kf=false;
@@ -630,5 +682,5 @@
   G4bool found=false;
   G4int i=-1;
-		if(nDB) for (i=0; i<nDB; i++) if(ind==vI[i])  // Sirch for this index in AMDB
+  if(nDB) for (i=0; i<nDB; i++) if(ind==vI[i])  // Sirch for this index in AMDB
   {
     found=true;                                 // The index is found
@@ -637,10 +689,10 @@
   G4double lp=std::log(p);
 #ifdef pdebug
-		G4cout<<"G4QuasiFreeR::FetchElTot:I="<<ind<<",i="<<i<<",fd="<<found<<",lp="<<lp<<G4endl;
+  G4cout<<"G4QuasiFreeR::FetchElTot:I="<<ind<<",i="<<i<<",fd="<<found<<",lp="<<lp<<G4endl;
 #endif
   if(!nDB || !found)                            // Create new line in the AMDB
-	 {
-#ifdef pdebug
-				G4cout<<"G4QuasiFreeRatios::FetchElTot: NewX, ind="<<ind<<", nDB="<<nDB<<G4endl;
+  {
+#ifdef pdebug
+    G4cout<<"G4QuasiFreeRatios::FetchElTot: NewX, ind="<<ind<<", nDB="<<nDB<<G4endl;
 #endif
     lastX = new std::pair<G4double,G4double>[mlp]; // Create logarithmic Table for ElTot
@@ -658,5 +710,5 @@
       lastX[j]=CalcElTot(pv,ind);
 #ifdef pdebug
-		    G4cout<<"G4QuasiFreeR::FetchElTot:I,j="<<j<<",pv="<<pv<<",E="<<lastX[j].first<<",T="
+      G4cout<<"G4QuasiFreeR::FetchElTot:I,j="<<j<<",pv="<<pv<<",E="<<lastX[j].first<<",T="
             <<lastX[j].second<<G4endl;
 #endif
@@ -670,5 +722,5 @@
   }
   else                                   // The A value was found in AMDB
-	 {
+  {
     lastI=vI[i];
     lastM=vM[i];
@@ -678,11 +730,11 @@
     G4double lpM=lastM+lpi;
 #ifdef pdebug
-		  G4cout<<"G4QuasiFreeR::FetchElTo:M="<<lpM<<",l="<<lp<<",K="<<lastK<<",n="<<nlp<<G4endl;
+    G4cout<<"G4QuasiFreeR::FetchElTo:M="<<lpM<<",l="<<lp<<",K="<<lastK<<",n="<<nlp<<G4endl;
 #endif
     if(lp>lpM && lastK<nlp)              // LogTab must be updated
-				{
+    {
       lastK = static_cast<int>((lp-lpi)/dl)+1; // MaxBin to be initialized in LogTab
 #ifdef pdebug
-		    G4cout<<"G4QuasiFreeR::FetET:K="<<lastK<<",lp="<<lp<<",li="<<lpi<<",dl="<<dl<<G4endl;
+      G4cout<<"G4QuasiFreeR::FetET:K="<<lastK<<",lp="<<lp<<",li="<<lpi<<",dl="<<dl<<G4endl;
 #endif
       if(lastK>nlp)
@@ -698,5 +750,5 @@
         lastX[j]=CalcElTot(pv,ind);
 #ifdef pdebug
-		      G4cout<<"G4QuasiFreeR::FetchElTot:U:j="<<j<<",p="<<pv<<",E="<<lastX[j].first<<",T="
+        G4cout<<"G4QuasiFreeR::FetchElTot:U:j="<<j<<",p="<<pv<<",E="<<lastX[j].first<<",T="
               <<lastX[j].second<<G4endl;
 #endif
@@ -704,5 +756,5 @@
     } // End of LogTab update
     if(lastK>=nextK)                   // The AMDB was apdated
-				{
+    {
       vM[i]=lastM;
       vK[i]=lastK;
@@ -719,4 +771,7 @@
   lastR.second=t+d*(lastX[n+1].second-t)/dl; // T-Result
   if(lastR.second<0.) lastR.second= 0.;
+#ifdef pdebug
+  G4cout<<"=O=>G4QuasiFreeR::FetchElTot:1st="<<lastR.first<<", 2nd="<<lastR.second<<G4endl;
+#endif
   if(lastR.first>lastR.second) lastR.first = lastR.second;
   return lastR;
@@ -728,4 +783,7 @@
 {
   G4double pGeV=pIU/gigaelectronvolt;
+#ifdef pdebug
+  G4cout<<"-->G4QuasiFreeR::GetElTot: P="<<pIU<<",pPDG="<<hPDG<<",Z="<<Z<<",N="<<N<<G4endl;
+#endif
   if(Z<1 && N<1)
   {
@@ -735,4 +793,8 @@
   std::pair<G4double,G4double> hp=FetchElTot(pGeV, hPDG, true);
   std::pair<G4double,G4double> hn=FetchElTot(pGeV, hPDG, false);
+#ifdef pdebug
+  G4cout<<"-OUT->G4QFRat::GetElTot: hp("<<hp.first<<","<<hp.second<<"), hn("<<hn.first<<","
+        <<hn.second<<")"<<G4endl;
+#endif
   G4double A=(Z+N)/millibarn;                // To make the result in independent units(IU)
   return std::make_pair((Z*hp.first+N*hn.first)/A,(Z*hp.second+N*hn.second)/A);
@@ -795,4 +857,7 @@
   N4M/=megaelectronvolt;
   G4LorentzVector tot4M=N4M+p4M;
+#ifdef ppdebug
+  G4cerr<<"->G4QFR::Scat:p4M="<<pr4M<<",N4M="<<N4M<<",t4M="<<tot4M<<",NPDG="<<NPDG<<G4endl;
+#endif
   G4double mT=mNeut;
   G4int Z=0;
@@ -843,12 +908,12 @@
   if(E<0. || E2<mP2)
   {
-#ifdef pdebug
+#ifdef ppdebug
     G4cerr<<"-Warning-G4QFR::Scat:*Negative Energy*E="<<E<<",E2="<<E2<<"<M2="<<mP2<<G4endl;
 #endif
     return std::make_pair(G4LorentzVector(0.,0.,0.,0.),p4M); // Do Nothing Action
   }
-		G4double P=std::sqrt(E2-mP2);                   // Momentum in pseudo laboratory system
+  G4double P=std::sqrt(E2-mP2);                   // Momentum in pseudo laboratory system
   G4VQCrossSection* CSmanager=G4QElasticCrossSection::GetPointer();
-#ifdef debug
+#ifdef ppdebug
   G4cout<<"G4QFR::Scatter: Before XS, P="<<P<<", Z="<<Z<<", N="<<N<<", PDG="<<pPDG<<G4endl;
 #endif
@@ -859,5 +924,5 @@
   G4double xSec=CSmanager->GetCrossSection(false, P, Z, N, PDG); // Rec.CrossSect *TMP*
   //G4double xSec=CSmanager->GetCrossSection(false, P, Z, N, pPDG); // Rec.CrossSect
-#ifdef debug
+#ifdef ppdebug
   G4cout<<"G4QElast::Scatter:pPDG="<<pPDG<<",P="<<P<<",CS="<<xSec/millibarn<<G4endl;
 #endif
@@ -869,5 +934,5 @@
   if(xSec <= 0.) // The cross-section iz 0 -> Do Nothing
   {
-#ifdef pdebug
+#ifdef ppdebug
     G4cerr<<"-Warning-G4QFR::Scat:**Zero XS**PDG="<<pPDG<<",NPDG="<<NPDG<<",P="<<P<<G4endl;
 #endif
@@ -878,5 +943,6 @@
   G4double maxt=CSmanager->GetHMaxT();            // max possible -t
 #ifdef ppdebug
-  G4cout<<"G4QFR::Scat:PDG="<<PDG<<",P="<<P<<",X="<<xSec<<",-t="<<mint<<"<"<<maxt<<", Z="<<Z<<",N="<<N<<G4endl;
+  G4cout<<"G4QFR::Scat:PDG="<<PDG<<",P="<<P<<",X="<<xSec<<",-t="<<mint<<"<"<<maxt<<", Z="
+        <<Z<<",N="<<N<<G4endl;
 #endif
 #ifdef nandebug
@@ -893,5 +959,5 @@
     else if(cost<-1.) cost=-1.;
     else
-				{
+    {
       G4cerr<<"G4QFR::S:*NAN*c="<<cost<<",t="<<mint<<",tm="<<CSmanager->GetHMaxT()<<G4endl;
       return std::make_pair(G4LorentzVector(0.,0.,0.,0.),p4M); // Do Nothing Action
@@ -907,7 +973,7 @@
   }
 #ifdef ppdebug
-		G4cout<<"G4QFR::Scat:p4M="<<pr4M<<"+r4M="<<reco4M<<",dr="<<dir4M<<",t4M="<<tot4M<<G4endl;
-#endif
-		return std::make_pair(reco4M*megaelectronvolt,pr4M*megaelectronvolt); // Result
+  G4cout<<"G4QFR::Scat:p4M="<<pr4M<<"+r4M="<<reco4M<<",dr="<<dir4M<<",t4M="<<tot4M<<G4endl;
+#endif
+  return std::make_pair(reco4M*megaelectronvolt,pr4M*megaelectronvolt); // Result
 } // End of Scatter
 
@@ -935,6 +1001,6 @@
     N=0;
     RPDG=2112;                                         // PDG of the recoil nucleon
-  		if(pPDG==-211) sPDG=111;                           // pi+    -> pi0
-  		else if(pPDG==-321)
+    if(pPDG==-211) sPDG=111;                           // pi+    -> pi0
+    else if(pPDG==-321)
     {
       sPDG=310;                                        // K+     -> K0S
@@ -948,6 +1014,6 @@
   else if(NPDG==2112) // Default
   {
-  		if(pPDG==211)  sPDG=111;                           // pi+    -> pi0
-  		else if(pPDG==321)
+    if(pPDG==211)  sPDG=111;                           // pi+    -> pi0
+    else if(pPDG==321)
     {
       sPDG=310;                                        // K+     -> K0S
@@ -983,5 +1049,5 @@
     return std::make_pair(G4LorentzVector(0.,0.,0.,0.),p4M); // Do Nothing Action
   }
-		G4double P=std::sqrt(E2-mS2);                   // Momentum in pseudo laboratory system
+  G4double P=std::sqrt(E2-mS2);                   // Momentum in pseudo laboratory system
   G4VQCrossSection* CSmanager=G4QElasticCrossSection::GetPointer();
 #ifdef debug
@@ -1025,5 +1091,5 @@
     else if(cost<-1.) cost=-1.;
     else
-				{
+    {
       G4cerr<<"G4QFR::C:*NAN*c="<<cost<<",t="<<mint<<",tm="<<CSmanager->GetHMaxT()<<G4endl;
       return std::make_pair(G4LorentzVector(0.,0.,0.,0.),p4M); // Do Nothing Action
@@ -1040,7 +1106,7 @@
   }
 #ifdef debug
-		G4cout<<"G4QFR::ChEx:p4M="<<p4M<<"+r4M="<<reco4M<<"="<<p4M+reco4M<<"="<<tot4M<<G4endl;
-#endif
-		return std::make_pair(reco4M*megaelectronvolt,pr4M*megaelectronvolt); // Result
+  G4cout<<"G4QFR::ChEx:p4M="<<p4M<<"+r4M="<<reco4M<<"="<<p4M+reco4M<<"="<<tot4M<<G4endl;
+#endif
+  return std::make_pair(reco4M*megaelectronvolt,pr4M*megaelectronvolt); // Result
 } // End of ChExer
 
@@ -1060,5 +1126,5 @@
   G4double p2=p*p;            
   G4double p4=p2*p2;
-		G4double dl1=std::log(p)-5.;
+  G4double dl1=std::log(p)-5.;
   G4double T=(6.75+.14*dl1*dl1+13./p)/(1.+.14/p4)+.6/(p4+.00013);
   G4double U=(6.25+8.33e-5/p4/p)*(p*sp+.34)/p2/p; 
Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsInterface.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsInterface.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/interface/src/G4StringChipsInterface.cc	(revision 1055)
@@ -23,5 +23,6 @@
 // * acceptance of all terms of the Geant4 Software license.          *
 // ********************************************************************
-//
+// !!! Was used in QBBC PL, NOW it is not. Must be absolete !!!
+// ============================================================
 
 //#define debug
